<?php
/*
TODO: split this file to match new files architecture (control, admin, dialog) but inside control_plan, admin_plan, dialog_plan main common files
*/
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . '/Model_esia.php';
include_once $path . '/libs/convert.lib.php';
include_once $path . '/plugin/plan/inc/common_plan.inc.php';

// Text Object Min & Max styles Properties
const OBJ_STYLES_LIMITS_MIN = array(
	'fontSize' => 10,
	'bgOpacity' => 0,
	'borderWidth' => 0,
	'borderRad' => 0,
	'padding' => 0
);
const OBJ_STYLES_LIMITS_MAX = array(
	'fontSize' => 70,
	'bgOpacity' => 1,
	'borderWidth' => 10,
	'borderRad' => 200,
	'padding' => 100
);
const CONV_SERVICE_VALUE_UNITS = array(
	'bytes' => 'B',
	'bytes/s' => 'Bps',
	'bps' => 'Bps',
	'second' => 's',
	'millisecond' => 'ms',
	'percent' => '%',
	'packet/s' => 'Pck/s',
	'packetps' => 'Pck/s',
	'temperature' => '°',
	'temp' => '°',
	'celsius' => '°',
	'connections' => '',
	'number' => ''
);

$isJSONResp = FALSE;
try
{
	if($action == 'confObjText')
	{
		$smarty->assign('planId', $planId);
		$obj = $_GET['obj'];
		$obj = json_decode($obj, true);
		$smarty->assign('object', $obj);
		$plan = Model_plan::getPlans($dbconnection, $user->getId(), $planId)[$planId];
		$planController = $apache_path . explode('?', $plan['type_controller'])[0];
		$smarty->assign('planController', $planController);
		$limits = array(
			'min' => OBJ_STYLES_LIMITS_MIN,
			'max' => OBJ_STYLES_LIMITS_MAX
		);
		$smarty->assign('limits', $limits);
	}
	elseif($action == 'updateObjText')
	{
		$isJSONResp = TRUE;

		$params = false;
		if(isset($_POST['params']))
		{
			$params = json_decode($_POST['params'], true); // False if not decoded
		}

		if(isset($_POST['object']) && $params)
		{
			$objParams = Model_plan::getObjectParamJSON($dbconnection, $_POST['object'], array());

			if (isset($params['position']))
			{
				$objParams['position'] = $params['position'];
			}
			if (isset($params['size']))
			{
				$objParams['size'] = $params['size'];
			}
			if (isset($params['text']))
			{
				$objParams['text'] = $params['text'];
			}
			if (isset($params['style']))
			{
				$objParams['style'] = checkObjTextMinMaxStylesVal($params['style']);
			}

			Model_plan::updateObjectParamJSON($dbconnection, $_POST['object'], json_encode($objParams), array());
			echo json_encode($_POST['object']); // We must return somthing or ajax promise doesn't go into done fct
		}
		else
		{
			echo json_encode(array('error' => "ERROR update : wrong object parameters type"));
		}
		exit(0);
	}
	elseif($action == 'getNodeServicesValNames')
	{
		$isJSONResp = TRUE;

		$rrdList = formatNodeRrdList($dbconnection, $lang, $_GET['nodeId']);

		echo json_encode($rrdList);
		exit(0);
	}
	elseif($action == 'getNodeServicesValues')
	{
		$isJSONResp = TRUE;

		$result = array('values' => array());
		$services = Model_esia::getServices($dbconnection, $_GET['nodeId']);
		$result['device_name'] = $services[0]['device_name'];

		// Reformat $_GET['values'] by service_id key to be reusable into a loop
		$objServices = array();
		foreach ($_GET['values'] as $val)
		{
			$objServices[$val['id']][] = array('name' => $val['name'], 'order' => $val['order']);
		}

		foreach ($services as $service)
		{
			// Only for services saved on the object
			if(array_key_exists($service['id'], $objServices))
			{
				// Get service related informations
				$common_name = Model_esia::getCommonName($lang, $service['name'], $service['check_plugin_name']);
				$serviceRrdInfo = Model_esia::getRRDInformationByServiceId($dbconnection, $service['id']);
				// Set data for each value saved on the object
				foreach ($objServices[$service['id']] as $valArr)
				{
					// Remove unexpected , char at the end or start of value (Can happen for some service regex)
					$value = preg_replace('/^,+|,+$/', '', $service['value'][$valArr['name']]);
					// Calc the original value to match with unit
					if (isset($serviceRrdInfo[$valArr['name']]['calc']))
					{
						$value = eval('return ' . $value . $serviceRrdInfo[$valArr['name']]['calc'] . ';');
					}
					// Get value unit
					$unit = trim($serviceRrdInfo[$valArr['name']]['unity']);
					// Convert unit to be more relevant
					if(isset(CONV_SERVICE_VALUE_UNITS[strtolower($unit)]))
					{
						$unit = CONV_SERVICE_VALUE_UNITS[strtolower($unit)];
					}
					// Convert to KB, MB, GB, ...
					if ($unit == 'B' || $unit == 'Bps') {
						$cBArr = Convert\bitsPerSecond($value);
						$value = $cBArr['value'];
						$unit = $cBArr['unity'];
					}

					$result['values'][$valArr['order']] = array(
						'order' => $valArr['order'],
						'name' => $common_name . ' > ' . ucfirst($valArr['name']),
						'value' => $value,
						'unit' => $unit,
						'state' => $service['state']
					);
				}
			}
		}

		echo json_encode($result);
		exit(0);
	}
	elseif($action == 'getNodeServicesData')
	{
		$isJSONResp = TRUE;

		$result = array('services' => array());
		$services = Model_esia::getServices($dbconnection, $_GET['nodeId']);
		$result['device_name'] = $services[0]['device_name'];

		// Reformat $_GET['services'] by service_id key to be reusable into a loop
		$objServices = array();
		foreach ($_GET['services'] as $srv)
		{
			$objServices[$srv['id']] = array('order' => $srv['order']);
		}

		foreach ($services as $service)
		{
			// Only for services saved on the object
			if(array_key_exists($service['id'], $objServices))
			{
				$common_name = Model_esia::getCommonName($lang, $service['name'], $service['check_plugin_name']);
				$order = $objServices[$service['id']]['order'];
				$message = preg_replace('/\|(.*)$/', '', $service['stdout']);

				$result['services'][$order] = array(
					'id' => $service['id'],
					'order' => $order,
					'name' => $common_name,
					'state' => $service['state'],
					'message' => $message
				);
			}
		}

		echo json_encode($result);
		exit(0);
	}
	elseif($action == 'confObjService')
	{
		$smarty->assign('planId', $planId);

		// Object parameters
		$obj = Model_plan::instanceObjectPlans($dbconnection, $_GET['id'], array($_GET['objId']), FALSE)[$_GET['objId']];
		$obj = $obj->toArray();
		$smarty->assign('object', $obj);

		// Nodes list
		$nodes = Model_esia::getNodeList($dbconnection, $user->getId(), null, Model_esia::NODE_INSTANCE);
		$list = array();
		foreach($nodes as $node)
		{
			$selected = false;
			if($node->getId() == $obj['params']['device_id'])
			{
				$selected = true;
			}
			$nodeGroup = $node->getGroup();
			if (is_null($nodeGroup)) {
				$nodeGroup = $lang['GROUPNODE_ROOT'];
			}
			$list[] = array(
				'id' => $node->getId(),
				'name' => $nodeGroup . ' > ' . $node->getName(),
				'selected' => $selected
			);
		}
		$smarty->assign('adm_list_node', $list);

		// Service values list
		$rrdList = array();
		$rrdOrderedList = array();
		// Do this only if there is alread values saved for this object. List will be updated anyway when node select change
		if (!empty($obj['params']['device_id']) && !empty($obj['params']['values']))
		{
			// Get a list of all values added on this object (service_id-value_name)
			$objSelectedVal = array();
			foreach ($obj['params']['values'] as $val)
			{
				$objSelectedVal[$val['order']] = $val['id'] . '-' .  $val['name'];
			}

			// Fetch list of all values available on this node
			$rrdList = formatNodeRrdList($dbconnection, $lang, $obj['params']['device_id'], $objSelectedVal);
			// Get all values applied on this object to display it into the sortable select
			foreach ($rrdList as $rrd)
			{
				if ($rrd['selected'])
				{
					$rrdOrderedList[$rrd['order']] = $rrd;
				}
			}
			// Sort by key because the keys = order number but keys can be in wrong order into the array
			ksort($rrdOrderedList);
		}
		$smarty->assign('rrdList', $rrdList);
		$smarty->assign('rrdOrderedList', $rrdOrderedList);

		// Services list
		$servicesList = array();
		$servicesOrderedList = array();
		// Do this only if there is alread service saved for this object. List will be updated anyway when node select change
		if (!empty($obj['params']['device_id']) && !empty($obj['params']['services']))
		{
			// Get a list of all services added on this object
			$servicesSelected = array();
			foreach ($obj['params']['services'] as $serv)
			{
				$servicesSelected[$serv['order']] = $serv['id'];
			}

			// Fetch list of all services available on this node
			$servicesList = getNodeServicesList($dbconnection, $lang, $obj['params']['device_id']);
			$servicesSelectedOrder = array_flip($servicesSelected);
			foreach($servicesList as $key => $service)
			{
				if(in_array($service['id'], $servicesSelected))
				{
					$servicesList[$key]['selected'] = TRUE;
					$servicesList[$key]['order'] = $servicesSelectedOrder[$service['id']];
				}
				else
				{
					$servicesList[$key]['selected'] = FALSE;
					$servicesList[$key]['order'] = NULL;
				}
			}
			// Get all values applied on this object to display it into the sortable select
			foreach ($servicesList as $service)
			{
				if ($service['selected'])
				{
					$servicesOrderedList[$service['order']] = $service;
				}
			}
			// Sort by key because the keys = order number but keys can be in wrong order into the array
			ksort($servicesOrderedList);
		}
		$smarty->assign('servicesList', $servicesList);
		$smarty->assign('servicesOrderedList', $servicesOrderedList);

		// Preview & Styles
		$plan = Model_plan::getPlans($dbconnection, $user->getId(), $planId)[$planId];
		$planController = $apache_path . explode('?', $plan['type_controller'])[0];
		$smarty->assign('planController', $planController);
		$limits = array(
			'min' => OBJ_STYLES_LIMITS_MIN,
			'max' => OBJ_STYLES_LIMITS_MAX
		);
		$smarty->assign('limits', $limits);

		// Display fields selected. Set all to default and replace the one of object subtype from the object saved values
		$optsSelected = json_decode($_GET['defOpts'], true);
		$optsSelected[$obj['params']['sub_type']] = $obj['params']['options'];
		$smarty->assign('optsSelected', $optsSelected);
	}
	elseif($action == 'updateObjService')
	{
		$isJSONResp = TRUE;

		if(is_numeric($_POST['object_id']) && isset($_POST['form_data']))
		{
			$formData = array();
			parse_str(urldecode($_POST['form_data']), $formData);
			// Get original object
			$obj = Model_plan::instanceObjectPlans($dbconnection, $_GET['id'], array($_POST['object_id']), FALSE)[$_POST['object_id']];
			$obj = $obj->toArray();

			// Update object for new parameters (keep position, size, ...)
			if(!empty($formData['sub_type']))
			{
				$obj['params']['sub_type'] = $formData['sub_type'];
			}
			$obj['params']['device_id'] = null;

			// Styles
			$obj['params']['style'] = array(
				'title' => array(
					'fontSize' => checkObjSingleStyleVal($formData['titleFontSize'], 'fontSize'),
					'fontColor' => substr($formData['titleFontColor'], 1), // Remove # for colors values
					'bgColor' => substr($formData['titleBgColor'], 1),
					'bgOpacity' => checkObjSingleStyleVal($formData['titleBgOpacity'], 'bgOpacity'),
				),
				'content' => array(
					'fontSize' => checkObjSingleStyleVal($formData['contentFontSize'], 'fontSize'),
					'fontColor' => substr($formData['contentFontColor'], 1),
					'bgColor' => substr($formData['contentBgColor'], 1),
					'bgOpacity' => checkObjSingleStyleVal($formData['contentBgOpacity'], 'bgOpacity'),
				),
				'box' => array(
					'borderColor' => substr($formData['borderColor'], 1),
					'borderWidth' => checkObjSingleStyleVal($formData['borderWidth'], 'borderWidth'),
					'borderRadTopLeft' => checkObjSingleStyleVal($formData['topLeftRad'], 'borderRad'),
					'borderRadTopRight' => checkObjSingleStyleVal($formData['topRightRad'], 'borderRad'),
					'borderRadBottomRight' => checkObjSingleStyleVal($formData['bottRightRad'], 'borderRad'),
					'borderRadBottomLeft' => checkObjSingleStyleVal($formData['bottLeftRad'], 'borderRad'),
					'padTop' => checkObjSingleStyleVal($formData['topPad'], 'padding'),
					'padRight' => checkObjSingleStyleVal($formData['rightPad'], 'padding'),
					'padBottom' => checkObjSingleStyleVal($formData['bottPad'], 'padding'),
					'padLeft' => checkObjSingleStyleVal($formData['leftPad'], 'padding'),
				)
			);

			// Size
			if(isset($_POST['size']))
			{
				$obj['params']['size'] = json_decode($_POST['size']);
			}

			// Node
			if(is_numeric($formData['selectNode']))
			{
				$obj['params']['device_id'] = $formData['selectNode'];
			}

			// Delete old data values and services
			$obj['params']['values'] = array();
			$obj['params']['services'] = array();

			// Specific data for each sub Type (Value, State, Message)
			switch ($formData['sub_type'])
			{
				case 'value':
					$obj = updObjServiceVal($obj, $formData);
					break;
				case 'state':
					$obj = updObjServiceState($obj, $formData);
					break;
				case 'message':
					$obj = updObjServiceMsg($obj, $formData);
					break;
			}

			// Update DB object
			Model_plan::updateObjectParamJSON($dbconnection, $_POST['object_id'], json_encode($obj['params']), array());

			echo json_encode($obj); // Return the new updated object
		}
		else
		{
			echo json_encode(array('error' => "ERROR update : missing form data"));
		}
		exit(0);
	}
}
catch(\EsiaDbException | \Plan\PlanException | \Exception $e)
{
	$errors[] = $e->getMessage();
}

if($isJSONResp == TRUE)
{
	echo json_encode(array('error' => $errors));
	exit(0);
}
else
{
	$smarty->assign('error_messages', $errors);
}

$smarty->display($templatePath . 'dialog_tools.html');

// Clean checkbox array vals
function cleanCheckBoxesVals($checkBoxes)
{
	// Clean array to have only true or false (checkboxes return a value if checked and nothing(null) if not)
	foreach ($checkBoxes as $key => $value)
	{
		if ($value !== null)
		{
			$checkBoxes[$key] = true;
		}
		else
		{
			$checkBoxes[$key] = false;
		}
	}

	return $checkBoxes;
}

// Update object service specific data for sub Type Value
function updObjServiceVal($obj, $formData)
{
	// Values
	if(!empty($formData['input_order_service_val']))
	{
		$orderVal = json_decode($formData['input_order_service_val']);
		// Get all values for each service ID
		foreach ($orderVal as $key => $rrd)
		{
			$rrdArray = explode("-", $rrd); // $rrdArray[0]: service id, $rrdArray[1]: value name
			$obj['params']['values'][] = array(
				'id' => $rrdArray[0],
				'name' => $rrdArray[1],
				'order' => $key,
			);
		}
	}

	// Options checkboxes
	$checkBoxes = array(
		'isDisplayValNode' => $formData['isDisplayValNode'],
		'isDisplayValStateColor' => $formData['isDisplayValStateColor'],
		'isDisplayValName' => $formData['isDisplayValName'],
	);
	$obj['params']['options'] = cleanCheckBoxesVals($checkBoxes);

	return $obj;
}

// Update object service specific data for sub Type State
function updObjServiceState($obj, $formData)
{
	// Services
	if(!empty($formData['input_order_service_state']))
	{
		$orderSrv = json_decode($formData['input_order_service_state']);
		// Get all services for each service ID
		foreach ($orderSrv as $key => $service)
		{
			$obj['params']['services'][] = array(
				'id' => $service,
				'order' => $key,
			);
		}
	}

	// Options checkboxes
	$checkBoxes = array(
		'isDisplayStateNode' => $formData['isDisplayStateNode'],
	);
	$obj['params']['options'] = cleanCheckBoxesVals($checkBoxes);
	// Other options
	$obj['params']['options']['selDisplayStateStateColor'] = $formData['selDisplayStateStateColor'];
	$obj['params']['options']['selDisplayStateServData'] = $formData['selDisplayStateServData'];

	return $obj;
}

// Update object service specific data for sub Type Message
function updObjServiceMsg($obj, $formData)
{
	// Service
	if(!empty($formData['msgServices']))
	{
		$obj['params']['services'][] = array(
			'id' => $formData['msgServices'],
			'order' => 0,
		);
	}

	// Options
	$checkBoxes = array(
		'isDisplayMsgNode' => $formData['isDisplayMsgNode'],
		'isDisplayMsgName' => $formData['isDisplayMsgName'],
	);
	$obj['params']['options'] = cleanCheckBoxesVals($checkBoxes);

	return $obj;
}

// Get a list of all values for all services of a device. Add selected tag true for all values (service_id-value_name) passed in the array $objSelectedVal
function formatNodeRrdList($dbconnection, $lang, $nodeId, $objSelectedVal=array())
{
	$rrdList = array();
	$objSelectedValOrder = array_flip($objSelectedVal);
	$services = Model_esia::getServices($dbconnection, $nodeId);
	foreach ($services as $service)
	{
		$common_name = Model_esia::getCommonName($lang, $service['name'], $service['check_plugin_name']);
		$values = array_keys($service['value']);
		foreach ($values as $val)
		{
			$value = $service['id'] . '-' . $val;
			$selected = false;
			$order = null;
			if(in_array($value, $objSelectedVal))
			{
				$selected = true;
				$order = $objSelectedValOrder[$value];
			}
			$rrdList[] = array(
				'value' => $value,
				'name' => $common_name . ' > ' . ucfirst($val),
				'selected' => $selected,
				'order' => $order
			);
		}
	}

	return $rrdList;
}

// Check if a value is between min & max limits & return value between those limits
function checkObjSingleStyleVal($val, $minMaxKey)
{
	// Be sure than val is a number
	$val = floatval($val); // float for opacity

	if ($val < OBJ_STYLES_LIMITS_MIN[$minMaxKey])
	{
		// If $val is < than min, set it equal to min
		$val = OBJ_STYLES_LIMITS_MIN[$minMaxKey];
	} elseif ($val > OBJ_STYLES_LIMITS_MAX[$minMaxKey])
	{
		// If $val is > than max, set it equal to max
		$val = OBJ_STYLES_LIMITS_MAX[$minMaxKey];
	}

	return $val;
}

// Check if all styles values are between they're min max limits for obj type text
function checkObjTextMinMaxStylesVal($style)
{
	// Font-size
	$style['fontSize'] = checkObjSingleStyleVal($style['fontSize'], 'fontSize');

	// Background-opacity
	$style['bgOpacity'] = checkObjSingleStyleVal($style['bgOpacity'], 'bgOpacity');

	// Border width
	$style['borderWidth'] = checkObjSingleStyleVal($style['borderWidth'], 'borderWidth');

	// Border radius
	$style['borderRadTopLeft'] = checkObjSingleStyleVal($style['borderRadTopLeft'], 'borderRad');
	$style['borderRadTopRight'] = checkObjSingleStyleVal($style['borderRadTopRight'], 'borderRad');
	$style['borderRadBottomLeft'] = checkObjSingleStyleVal($style['borderRadBottomLeft'], 'borderRad');
	$style['borderRadBottomRight'] = checkObjSingleStyleVal($style['borderRadBottomRight'], 'borderRad');

	// Padding
	$style['padTop'] = checkObjSingleStyleVal($style['padTop'], 'padding');
	$style['padBottom'] = checkObjSingleStyleVal($style['padBottom'], 'padding');
	$style['padLeft'] = checkObjSingleStyleVal($style['padLeft'], 'padding');
	$style['padRight'] = checkObjSingleStyleVal($style['padRight'], 'padding');

	return $style;
}
?>
