/*
TODO: split this file to match new files architecture (control, admin, dialog)
*/

// Set the object rack on u
function setRackItemOnU(container, uPos, uSize, posGap=0) {
	var rackU = $('.rack-u-' + uPos),
		rackUHeight = rackU[0].getBoundingClientRect().height; // Get floating point value for more precision

	container.css({
		top: (rackU.position().top - posGap) + "px",
		height: (rackUHeight * uSize) + "px",
	});
}

// Set the rack u obj link id data on object load
// function initObjRackLinkU(obj) {
// 	var objSize = obj.params.common.u_size,
// 		uPos = obj.params.common.u_position;
//
// 	while (objSize > 0) {
// 		$('.rack-u-' + uPos).attr('data-link-id', obj.id);
//
// 		objSize--;
// 		uPos--;
// 	}
// }

// Open node state table
function openRackItemNodeStateTable(objId, objParams) {
	if (objParams?.config?.device_id !== undefined) {
		var langSubType = glob_lang.PLAN_RACK_ITEM,
			objOnRackPos = "U" + objParams?.common?.u_position;

		// Get rack item type name by lang
		if (objParams?.common?.item_type !== undefined) {
			langSubType = "PLAN_ELT_" + objParams?.common?.item_type.toUpperCase();
		}

		// Calc rack item U postion limits
		if (objParams?.common?.u_size > 1) {
			objOnRackPos += " > U" + (parseInt(objParams?.common?.u_position) - parseInt(objParams?.common?.u_size) + 1);
		}

		getObjectsDetails(objId, glob_lang[langSubType] + " - " + objOnRackPos);
	}
}

// Set the object rack item icon svg
function setObjRackItemSVG(container) {
	var originalSvgSelector = "#svg_rack_elt_" + container.attr("data-item-type"),
		subType = container.attr("data-item-subtype");

	if (subType !== undefined && subType !== "none") {
		originalSvgSelector += "_" + subType + "_" + container.attr("data-u-size") + "u";
	} else {
		originalSvgSelector += "_" + container.attr("data-u-size") + "u";
	}

	container.append($(originalSvgSelector).clone());
}

// Set object rackItem states icons
function setObjRackItemStates(objId, config) {
	if (config?.device_id !== undefined && config?.services !== undefined) {
		$.ajax({
			type: "POST",
			url: glob_apache_path + "display_rack.php",
			data: {action: "getObjRackItemStates", nodeId: config.device_id, services: config.services},
			dataType: "json"
		})
		.done(function(data) {
			if (data.error) {
				// Error Message
				displayUserMessage(data.error, true);
			} else {
				var objectImg = $("#" + objId + "object > svg");

				$(".elt-state-global", objectImg).css("fill", PLAN_SERVICE_STATE_COLORS[data.nodeState] || PLAN_SERVICE_STATE_COLORS[3]);

				$.each(data.services, function(tag, state) {
					// Selector ".elt-state-" + tag for use tag with class like elt-state-ping. Selector .elt-" + tag + " use.rack-elt-state" for group of use tags like g of class elt-disks or fans
					let elt = $(".elt-state-" + tag + ", .elt-" + tag + " use.rack-elt-state", objectImg);
					if(state == -1) {
						// No services behind remove fill color to set icon to not configured
						elt.css("fill", "");
					}
					else {
						elt.css("fill", PLAN_SERVICE_STATE_COLORS[state] || PLAN_SERVICE_STATE_COLORS[3]);
					}
				});
			}
		});
	}
}

// Common tasks used to create obj rack item on the rack (admin and view mode)
function setObjectRackItemCommon(obj, containerClasses="planObjView", deviceName='') {
	var plan = $("#plan" + glob_plan.id),
		container = $("<div>", {
			"id": obj.id + "object",
			"class": "objRackItem " + containerClasses,
			"data-id": obj.id,
			"data-type": obj.type_name,
			"data-item-type": obj.params.common.item_type,
			"data-item-subtype": obj.params.common.item_subtype,
			"data-u": obj.params.common.u_position,
			"data-u-size": obj.params.common.u_size,
			"title": deviceName,
		});

	setObjRackItemSVG(container);
	setRackItemOnU(container, obj.params.common.u_position, obj.params.common.u_size);

	$(".rack-objects", plan).append(container);

	addTooltipTitle(container);
}

// Set an object on the rack
function setObjectRackItem(obj, deviceName='') {
	setObjectRackItemCommon(obj, "planObjView", deviceName);

	var container = $("#" + obj.id + "object");

	setObjRackItemStates(obj.id, obj.params?.config);

	// Click actions
	container.on("click", function(e) {
		if (e.ctrlKey) {
			// Open node state table on ctrl + click
			openRackItemNodeStateTable(obj.id, obj.params);
		} else {
			// Avoid re-zoom if the document click is on this
			e.stopPropagation();

			// Re-init some stuff if other obj previously zoomed
			$(".zoomedObj-details").remove();
			$(document).off(".unzoomObjEvent");

			// Create show details button
			if ((obj.params?.config?.device_id !== undefined) && !$(this).hasClass("zoomedObj")) {
				var detailsButton = $("<button>", {
						"class": "zoomedObj-details",
						"type": "button",
						"title": glob_lang.PLAN_SHOW_DETAILS,
					});

				container.append(detailsButton);
				detailsButton.on("click", function() {
					// Open node state table on ctrl + click
					openRackItemNodeStateTable(obj.id, obj.params);
				});

				addTooltipTitle(detailsButton);
			}

			// Zoom on normal click
			$(".zoomedObj").not(this).removeClass("zoomedObj");
			$(this).toggleClass("zoomedObj");

			// Close on click any where or keyboard press
			$(document).on("click.unzoomObjEvent keydown.unzoomObjEvent", function(e) {
				// Escape press or simple click (not ctrl click)
				if (e.keyCode == undefined || e.keyCode == 27) {
					$(".zoomedObj").removeClass("zoomedObj");
					$(".zoomedObj-details").remove();
					// Remove event handler when condition match
					$(document).off(".unzoomObjEvent");
				}
			});
		}
	});
}

// Set an object on the rack and set modification options related to admin mode
function adm_setObjectRackItem(obj, deviceName='') {
	setObjectRackItemCommon(obj, "planObj", deviceName);

	var container = $("#" + obj.id + "object");

	dragObjRackItem(container);
	initObjRackItemMenu(container);
}

// Open obj rack item configuration dialog
function configObjRackItem(objId) {
	var url = glob_apache_path + "dialog_rack.php?action=updateObjRackItem&id=" + $("#currentPlan").data("id"),
		requestData = { objId: objId },
		dialogParams = { height: 800 };

	if(!$.isNumeric(objId)) {
		// Object not already saved in DB but somme params can be updated by the user
		requestData.objParamsCommon = getObjRackItemCommonParams(objId);
	}

	openDialogByAJAX(url, requestData, glob_lang.PLAN_RACK_ITEM_CONF, 'dialog-info', dialogParams);
}

// Get common obj params from html data attributes
function getObjRackItemCommonParams(objId) {
	var obj = $('#' + objId + 'object');

	return {
		item_type: obj.attr('data-item-type'),
		item_subtype: obj.attr('data-item-subtype'),
		u_size: obj.attr('data-u-size'),
		u_position: obj.attr('data-u'),
	};
}

// Initialize rack item obj menu
function initObjRackItemMenu(container) {
	container.on("click", function() {
		if (container.find(".plan-obj-infos").length == 0) {
			openObjRackItemMenu(container);
		}
	});
}

// Open object acions box
function openObjRackItemMenu(container) {
	var planId = $("#currentPlan").data("id"),
		objId = container.data("id"),
		actions = $("<div>", {"class": "plan-obj-actions"}),
		closeButton = $("<button>", {"class": "obj-action close-action", "type": "button", "title": glob_lang.PLAN_CLOSE}),
		modifyButton = $("<button>", {"class": "obj-action modify-action", "type": "button", "title": glob_lang.PLAN_MODIFY}),
		delButton = $("<button>", {"class": "obj-action delete-action", "type": "button", "title": glob_lang.PLAN_TO_TRASH});

	if (!const_rack_items_types_not_node.includes(container.data("item-type"))) {
		actions.append(modifyButton);
	}
	actions.append(delButton).append(closeButton);
	initObjectEditMenu(container, actions);

	// Close
	closeButton.on("click", function() {
		closeObjectEditMenu(container);
	});

	// Modify parameters
	modifyButton.on("click", function() {
		if ($.isNumeric(planId)) {
			configObjRackItem(objId);
			closeObjectEditMenu(container);
		}
	});

	// Delete object
	delButton.on("click", function() {
		closeObjectEditMenu(container);
		moveRackItemToTrash(objId);
	});
}

// Calc draggable snap tolerance value (px) depending on the zoom value
function setSnapTolerance() {
	return (glob_plan.params.rack.zoom / 5); // 20px for zoom 100%
}

// Drag an object rack_item
function dragObjRackItem(object) {
	object.draggable({
		containment: ".rack-objects",
		snap: ".snapContainer",
		snapMode: "inner",
		snapTolerance: setSnapTolerance(),
		revert: "invalid",
		cursor: "move",
		appendTo: ".rack-objects",
		helper: "original",
		start: function(e, ui) {
			// On start we have to fix a height on the helper or it will be 0 because it's fixed only on the menuItems
			var rackUHeight = $(".rack-u-1").outerHeight(), // Take height on the first rack U
				uSize = $(this).attr("data-u-size");

			$(ui.helper).css({
				height: (rackUHeight * uSize) + "px",
			});
		},
		stop: function(e, ui) {
			setRackEmtyUSeparators();
		},
	});
}

// Drag multiples plan Rack Items objects together
function multiDragPlanRackItems() {
	// Create a container for each rack-items selected and drag this container instead with all rack-items inside
	$("#plan" + glob_plan.id).on("newMultiSelect", function() {
		var newSelected = $(".rack-objects > .objRackItem.planObj-selected"),
			selected = $(".objRackItem.planObj-selected"),
			uLimits = {max: 1, min: const_rack_limits.uSizeMax}, // Revert min & max U positions values to be sure first object erase it
			selectionHeight = $(".rack-u-1").outerHeight(), // Initialize value with the height of one U
			selectedContainerTop = 0;

		// Retrieve first and last U of selection in order to calc container height & position
		selected.each(function(index, element) {
			var eltULimits = {max: parseInt($(element).attr("data-u")), min: parseInt($(element).attr("data-u")) - (parseInt($(element).attr("data-u-size")) - 1)};

			if (eltULimits.max > uLimits.max) {
				uLimits.max = eltULimits.max;
			}

			if (eltULimits.min < uLimits.min) {
				uLimits.min = eltULimits.min;
			}

			$(element).draggable("disable");
		});

		// Create container & add items inside
		if (newSelected.length > 0) {
			if ($(".rack-objects > .rackItemsSelected").length == 0) {
				// First selection
				var selectedContainer = $("<div>", {"class": "rackItemsSelected planObj-selected common-multi-drag-disabled"});

				$(".rack-objects").append(selectedContainer);
			}
			// Add elements to selection
			$(".rack-objects .rackItemsSelected").append(newSelected);
		}

		// Set container height & position
		selectionHeight = selectionHeight * ((uLimits.max - uLimits.min) + 1);
		selectedContainerTop = $(".rack-u-" + uLimits.max).position().top;

		$(".rackItemsSelected").css({
			height: selectionHeight + "px",
			top: selectedContainerTop + "px",
		});

		// Re-calc elements positions inside container. Because they are no longer relatively positioned from rack but from this container wich is also positioned inside the rack
		newSelected.each(function(index, element) {
			$(element).css({
				top: $(element).position().top - selectedContainerTop + "px",
			});
		});
		// Update position on previously selected elements wich are already inside selected container because it's size change when adding new elements to selection
		selected.each(function(index, element) {
			setRackItemOnU($(element), $(element).attr('data-u'), $(element).attr('data-u-size'), selectedContainerTop);
		});

		// Set selection container dragg
		$(".rackItemsSelected").draggable({
			containment: ".rack-objects",
			snap: ".snapContainer",
			snapMode: "inner",
			snapTolerance: setSnapTolerance(),
			revert: "invalid",
			cursor: "move",
			appendTo: ".rack-objects",
			create: function() {
				// Re-enable multi dragging to add this select container to the multi dragg elements list
				enableMultiDragOnSelectedObj();
			},
			stop: function(e, ui) {
				// Set new positions on rack
				var selectedContainerTop = $(".rackItemsSelected").position().top;

				$(".objRackItem.planObj-selected").each(function(index, element) {
					var obj = $(element),
						objId = obj.attr('data-id'),
						objSize = obj.attr('data-u-size'),
						uPos = getObjRackUPosOnDrop(obj.position().top + selectedContainerTop),
						replacedObjIds = [];

					// Check if postion as been correctly retrieved
					if (uPos > 0) {
						obj.attr('data-u', uPos);

						// Set obj id on rack u data
						replacedObjIds = setObjRackULinkedId(objId, objSize, uPos);

						for (var i = 0; i < replacedObjIds.length; i++) {
							// Do not send to trash objects which are currently dragged together because they have been moved after checking if they where on the same u
							if (!$("#" + replacedObjIds[i] + "object").hasClass("planObj-selected")) {
								moveRackItemToTrash(replacedObjIds[i]);
							}
						}
					} else {
						// If no U position found move the object to trash & remove it from selected
						obj.removeClass("planObj-selected");
						moveRackItemToTrash(objId);
					}

					// Update position on U with selected container as relative parent
					setRackItemOnU($(element), uPos, objSize, selectedContainerTop);
				});

				setRackEmtyUSeparators();

				// Send event to register unsaved changes
				$(".rack-container").trigger("rack-changes");
			},
		});

		// Self handle dragg positions not handled by common drag.multiDrag event
		$(".rackItemsSelected").on("multidrag:drag", function(e, ui, draggedOffset) {
			var parent = $(this).parent(),
				bottomLimit = parent.height() - $(this).outerHeight(),
				newPosTop = ui.originalPosition.top + draggedOffset.top + parent.scrollTop();

			// Check values to keep all selected elements in parent limits
			if (newPosTop < 0) {
				newPosTop = 0;
			} else if (newPosTop > bottomLimit) {
				newPosTop = bottomLimit;
			}

			$(this).css("top", newPosTop + "px");
		});

		// Set multi drag events to correctly work when draggin another object type with rack items in the selection
		$(".rackItemsSelected").on("multidrag:stop", function(e, ui) {
			var stop = $(this).draggable("option", "stop");

			if (stop !== null) {
				// Apply is used to pass element context as this
				stop.apply($(this), [e, ui]);
			}
		});
	});

	// Reset some values & destroy selection container when multi selection end
	$("#plan" + glob_plan.id).on("removeMultiSelect", function() {
		var multiSelected = $(".rackItemsSelected .planObj");

		$(".rack-objects").append(multiSelected);
		multiSelected.each(function(index, element) {
			// Reset objects real U position after multi select container removall because now relative parent is rack-objects container
			setRackItemOnU($(element), $(element).attr('data-u'), $(element).attr('data-u-size'));

			$(element).draggable("enable");
		});
		$(".rackItemsSelected").remove();
	});
}

// Drag an object rack_item from the menu
function dragMenuRackItem() {
	$('.menuItem .objRackItem').each(function() {
		dragObjRackItem($(this));
		$(this).draggable("option", "helper", "clone");
		$(this).draggable("option", "containment", "#plan" + glob_plan.id);
	});
}

// Get the u position on rack when an object is droppend on it
function getObjRackUPosOnDrop(positionTop) {
	var minDraggPosTop = positionTop - 15, // Gap value must be at least half of rack-u height to match even when snap is bug on scroll
		maxDraggPosTop = positionTop + 15,
		uPos = 0;

	// For each rack-u search the one which is the closest of postion top
	$(".rack-u").each(function() {
		if ($(this).position().top > minDraggPosTop && $(this).position().top < maxDraggPosTop) {
			uPos = $(this).attr('data-u');
			return false; // Break the each loop
		}
	});

	return uPos;
}

// Set obj id on rack-u data-link-id and remove obj id from previous rack-u. Return objects id if other objects was setted on thoses new rack-u
function setObjRackULinkedId(objId, objSize, uPos) {
	var busyObjIds = []; // Severall obj can be replaced by a bigger one
	// Reset previous obj U link
	$(".rack-u[data-link-id='" + objId + "']").attr('data-link-id', 0);

	while (objSize > 0) {
		var rackU = $('.rack-u-' + uPos),
			rackULinkedId = rackU.attr('data-link-id');

		// Check if another object was linked on this U
		if (rackULinkedId != 0) {
			var isInArray = false,
				i = 0;

			for (; i < busyObjIds.length; i++) {
				if (rackULinkedId == busyObjIds[i]) {
					isInArray = true;
					break;
				}
			}

			if (!isInArray) {
				busyObjIds.push(rackULinkedId);
			}
		}

		// Set new obj U link
		rackU.attr('data-link-id', objId);

		objSize--;
		uPos--;
	}

	return busyObjIds;
}

// Check if trash contain object or not and disable it if empty
function handleIsTrashDisabled() {
	var trashContentLength = $(".trash .objRackItem").length;

	$(".trash span").attr("data-nbr", trashContentLength);

	if (trashContentLength > 0) {
		$(".trash").removeClass("isDisabled");
	} else {
		$(".trash").addClass("isDisabled");
	}
}

// Move an rack object to the trash
function moveRackItemToTrash(objId) {
	var replObj = $("#" + objId + "object"),
		menuItem = $("<li>", {"class": "menuItem"});

	replObj.attr('data-u', 0);
	replObj.css({
		"top": 0,
		"bottom": 0,
		"left": 0,
		"right": 0,
	});

	replObj.removeClass("planObj");
	replObj.addClass("trashObj");
	menuItem.append(replObj);
	$(".trash-content").append(menuItem);

	handleIsTrashDisabled();

	// Remove old rack u link. The replaced obj can be bigger than the new object so empty places must be reset to 0
	$(".rack-u[data-link-id='" + objId + "']").attr('data-link-id', 0);
	setRackEmtyUSeparators();

	replObj.draggable("option", "helper", "clone");
	replObj.draggable("option", "containment", "#plan" + glob_plan.id);
}

// Drop an object rack_item on the rack
function dropObjInRack() {
	$(".rack-container .rack-objects").droppable({
		tolerance: "intersect",
		accept: ".objRackItem, .rackItemsSelected",
		drop: function(e, ui) {
			var obj = $(ui.draggable);

			// Prevent to use this function in case of multi-select because it use it's own function multiDragPlanRackItems
			if (obj.hasClass("planObj-selected")) {
				return;
			}

			var objId = $(ui.draggable).attr('data-id'),
				objSize = $(ui.draggable).attr('data-u-size'),
				uPos = getObjRackUPosOnDrop(ui.position.top),
				replacedObjIds = [];

			if (obj.hasClass("menuObj")) {
				// New obj dragged from menu
				obj = obj.clone();
				obj.empty();
				setObjRackItemSVG(obj);

				obj.removeClass("menuObj");
				obj.addClass("planObj newObj");
				objId = 'tmp-' + Date.now();
				obj.attr('id', objId + "object");
				obj.attr('data-id', objId);
				$('.rack-objects').append(obj);

				dragObjRackItem(obj);
				obj.tooltipster({theme: 'tooltipster-borderless'});
				initObjRackItemMenu(obj);
			} else if (obj.hasClass("trashObj")) {
				// Object dragged from the trash
				var menuItem = obj.parent(".menuItem");

				obj.removeClass("trashObj");
				obj.addClass("planObj");
				$('.rack-objects').append(obj);
				menuItem.remove();
				handleIsTrashDisabled();

				obj.draggable("option", "helper", "original");
				obj.draggable("option", "containment", ".rack-objects");
			}

			// Check if postion as been correctly retrieved
			if (uPos > 0) {
				obj.attr('data-u', uPos);
				// Set position and size to be sure we match the U
				setRackItemOnU(obj, uPos, objSize);

				// Set obj id on rack u data
				replacedObjIds = setObjRackULinkedId(objId, objSize, uPos);
			} else {
				// If no U position found move the object to trash
				replacedObjIds[0] = objId;
			}

			// If rack u is not empty
			if (replacedObjIds.length > 0) {
				for (var i = 0; i < replacedObjIds.length; i++) {
					moveRackItemToTrash(replacedObjIds[i]);
				}
			}
		},
	});
}

// Show/hide trash content
function showHideTrashContent() {
	$(".navigation .toggleSubMenu-single .subMenuTitle").click(function(e) {
		var toggleSubMenu = $(this).parent();

		if (!toggleSubMenu.hasClass("isDisabled")) {
			$(".subMenu-single", toggleSubMenu).slideToggle("normal", function() {
				toggleSubMenu.toggleClass("open");
			});
		}
	});
}

// Be sure that values are between min max limits
function validRackLimits(uSize=null, zoom=null) {
	var validValues = {
		u_size: uSize,
		zoom: zoom,
	};

	if (uSize != null) {
		if (uSize < const_rack_limits.uSizeMin) {
			validValues.u_size = const_rack_limits.uSizeMin;
		} else if (uSize > const_rack_limits.uSizeMax) {
			validValues.u_size = const_rack_limits.uSizeMax;
		}
	}

	if (zoom != null) {
		if (zoom < const_rack_limits.zoomMin) {
			validValues.zoom = const_rack_limits.zoomMin;
		} else if (zoom > const_rack_limits.zoomMax) {
			validValues.zoom = const_rack_limits.zoomMax;
		}
	}

	return validValues;
}

// Add uSize number of rack U or additional U on an existing rack
function addRackU(uSize, uStartId=1) {
	var uParts = $(".rack-u-parts"),
		rackU = $(".rack-u-1", uParts).clone().removeClass("rack-u-1").attr("data-link-id", 0);

	while (uStartId <= uSize) {
		var newU = rackU.clone().addClass("rack-u-" + uStartId).attr("data-u", uStartId);

		uParts.prepend(newU);

		uStartId++;
	}
}

// Remove uSize number of rack U on an existing rack
function removeRackU(newUSize, currentUSize) {
	while (newUSize < currentUSize) {
		var rackU = $(".rack-u-" + currentUSize),
			linkedId = rackU?.attr('data-link-id') || "0";

		// If an object is on the rack U put it to the trash
		if (linkedId != 0) {
			moveRackItemToTrash(linkedId);
		}
		rackU.remove();

		currentUSize--;
	}
}

// Modify rack parameters
function handleRackParameters() {
	// Change rack size
	$("#inputUSize").on("change", function() {
		validValues = validRackLimits(parseInt($(this).val()), null);
		glob_plan.params.rack.u_size = parseInt(glob_plan.params.rack.u_size); // Safety because the first value retreived from the controller may not be an integer
		// Update field in case of the value was not between limits
		$(this).val(validValues.u_size);
		// Apply new U elements on rack if u size higher or smaller thant before
		if (validValues.u_size > glob_plan.params.rack.u_size) {
			addRackU(validValues.u_size, glob_plan.params.rack.u_size + 1);
		} else if (validValues.u_size < glob_plan.params.rack.u_size) {
			removeRackU(validValues.u_size, glob_plan.params.rack.u_size);
		}
		// Save in global rack var
		glob_plan.params.rack.u_size = validValues.u_size;
		// Trigger contentupdated to update rack items objects
		$(".rack-content").trigger("contentupdated");
		setRackEmtyUSeparators();
	});
	// Change rack zoom
	$("#inputZoom").on("change", function() {
		validValues = validRackLimits(null, parseInt($(this).val()));
		// Update field in case of the value was not between limits
		$(this).val(validValues.zoom);
		// Apply new zoom
		$(".rack-zoom").css("width", validValues.zoom + "%");
		// Save in global rack var
		glob_plan.params.rack.zoom = validValues.zoom;
		// Change rack-u font size
		if (validValues.zoom < 80) {
			$(".rack-u-parts").css("font-size", "10px");
		} else {
			$(".rack-u-parts").css("font-size", "12px");
		}
		// Update snapTolerance
		$(".objRackItem").draggable( "option", "snapTolerance", setSnapTolerance());
		$(".rackItemsSelected").draggable( "option", "snapTolerance", setSnapTolerance());

		// Trigger contentupdated to update rack items objects
		$(".rack-content").trigger("contentupdated");
	});
	// Show/Hide empty U
	$("#isEmptyUHidden").on("change", function() {
		if ($(this).is(":checked") == true) {
			$(".rack-content").addClass("empty-u-hidden");
		} else {
			$(".rack-content").removeClass("empty-u-hidden");
		}
		setRackEmtyUSeparators();
		// Trigger contentupdated to update rack items objects
		$(".rack-content").trigger("contentupdated");
	});
	// On update modify objects
	$(".rack-content").on("contentupdated", function() {
		// Update all rack items objects position and size
		$('.planObj.objRackItem').each(function() {
			setRackItemOnU($(this), $(this).attr("data-u"), $(this).attr("data-u-size"));
		});
	});
}

// Get the ids of the object in the trash with valid db id (not tmp object which are not saved yet)
function getTrashObjWithDbId() {
	var deleteObj = [],
		regex = new RegExp("^\\d+$");

	$(".trashObj").each(function() {
		var objId = $(this).attr("data-id");
		// If object ID is an integer it's a object saved in DB (if the object is not saved yet its ID begin by tmp-)
		if(regex.test(objId)) {
			deleteObj.push(objId);
		}
	});

	return deleteObj;
}

// Wait for the user to valid trash content deletion before save the plan
function validEmptyTrashOnSavePromise() {
	return new Promise(function(resolve) {
		var deleteObj = [];

		if ($(".trash-count").attr("data-nbr") > 0) {
			// On save empty trash confirm dialog
			var url = glob_apache_path + "dialog_rack.php?action=emptyTrashOnSave&id=" + $("#currentPlan").data("id"),
				dialogParams = {
					title: glob_lang.PLAN_CAUTION,
					resizable: false,
					draggable: false,
					width: 300,
					maxHeight: false,
					position: {
						my: "right top",
						at: "right bottom",
						of: $(".plan-main-title"),
					}
				};

			openDialogByAJAX(url, {}, '', 'dialog-info', dialogParams);

			// We listen a custom event send on the dialog because we cannot create a listener on it's content now because it's setted by an ajax promise and does not exist yet
			$('#dialog-info').one("validation", function() {
				// User choose to valid trash empty
				deleteObj = getTrashObjWithDbId();
				$(this).dialog("close");

				resolve(deleteObj);
			});
		} else {
			// Trash is empty do nothing
			resolve(deleteObj);
		}
	});
}

// Save plan rack parameters, objects and plan global modifications
function updatePlanRack() {
	$("#edit_infos").submit(function(e) {
		e.preventDefault();

		// Wait for the user to valid trash content deletion before save the plan
		validEmptyTrashOnSavePromise()
			.then(function(deleteObj) {
				var planId = $("#currentPlan").val(),
					rackObjects = [];

				savePlanSize();

				// Get info about each obj rack item on the rack only
				$(".objRackItem.planObj").each(function() {
					var obj = {
						info: {
							id: $(this).attr("data-id"),
							isNew: false,
						},
						common: {
							item_type: $(this).attr("data-item-type"),
							item_subtype: $(this).attr("data-item-subtype"),
							u_size: $(this).attr("data-u-size"),
							u_position: $(this).attr("data-u"),
						},
					};

					if ($(this).hasClass("newObj")) {
						obj.info.isNew = true;
					}

					rackObjects.push(obj);
				});

				// Save values into $("#edit_infos") form hidden inputs
				$("#rack_params").val($("#edit_rack").serialize()); // $("#edit_rack") form
				$("#rack_objects").val(JSON.stringify(rackObjects));
				$("#delete_objects").val(JSON.stringify(deleteObj));

				// Send the form
				e.currentTarget.submit();
			});
	});
}

// On plan changes set var to true to know if we have unsaved changes
function handlePlanHasUnsavedChanges() {
	// glob_plan_has_changes is reset to false on page load. A save action reload the page

	// Global plan informations changes
	$("#edit_infos input, #edit_infos select").change(function() {
		glob_plan_has_changes = true;
	});
	// Rack parameters changes
	$("#edit_rack input").change(function() {
		glob_plan_has_changes = true;
	});
	// Drop obj on the rack
	$(".rack-container .rack-objects").on("drop", function() {
		glob_plan_has_changes = true;
	});
	// Custom rack changes event to trigger
	$(".rack-container").on("rack-changes", function() {
		glob_plan_has_changes = true;
	});

	// On plan admin leave check if there is unsaved changes
	$("#planLeave").on("click", function(e) {
		// If something in the trash there is changes
		if ($(".trash-count").attr("data-nbr") > 0) {
			glob_plan_has_changes = true;
		}

		// If there is unsaved changes
		if (glob_plan_has_changes) {
			e.preventDefault();

			var url = glob_apache_path + "dialog_rack.php?action=unsavedPlanDialog&id=" + $("#currentPlan").data("id"),
				dialogParams = {
					title: glob_lang.PLAN_CAUTION,
					resizable: false,
					draggable: false,
					width: 300,
					maxHeight: false,
					position: {
						my: "right top",
						at: "right bottom",
						of: $(".plan-main-title"),
					}
				};

			openDialogByAJAX(url, {}, '', 'dialog-info', dialogParams);

			$('#dialog-info').one("validation", function() {
				window.location = $("#planLeave").attr('href');
			});
		}
	});
}

// Open empty trash dialog
function openEmptyTrashDialog() {
	$(".trash-action-empty").on("click", function(e) {
		// Prevent event to bubble up to its parent which cause toggle trash menu
		e.stopPropagation();
		e.preventDefault();

		var url = glob_apache_path + "dialog_rack.php?action=emptyTrash&id=" + $("#currentPlan").data("id"),
			dialogParams = {
				title: glob_lang.PLAN_TRASH,
				resizable: false,
				draggable: false,
				width: 300,
				maxHeight: false,
				position: {
					my: "right top",
					at: "right bottom",
					of: $(".trash .subMenuTitle"),
				}
			};

		openDialogByAJAX(url, {}, '', 'dialog-info', dialogParams);
	});
}

// Action to empty the trash
function emptyTrash() {
	$("#formEmptyTrash").submit(function(e) {
		e.preventDefault();

		var formData = getFormValues('formEmptyTrash'),
			deleteObj = getTrashObjWithDbId();

		if(deleteObj.length > 0) {
			// Remove DB saved objects
			$.ajax({
				type: "POST",
				url: $(this).attr("action"),
				data: { isJSONResp: true, ...formData, delete_objects: deleteObj },
				dataType: "json"
			})
			.done(function(data) {
				if(data.error) {
					// Error Message
					displayUserMessage(data.error, true, 'dialog-messages');
				} else {
					// Remove all remaining trash content
					$(".trash-content").empty();
					handleIsTrashDisabled();
					$("#dialog-info").dialog("close");
				}
			});
		}
		else {
			$(".trash-content").empty();
			handleIsTrashDisabled();
			$("#dialog-info").dialog("close");
		}
	});
}

// Update the service selection options
function updRackItemSelectServices(obj, selectFields) {
	if (obj.params.config.device_id != null) {
		$.ajax({
			type: "GET",
			url: glob_apache_path + "display_rack.php",
			data: {action: "getNodeServices", nodeId: obj.params.config.device_id, itemType: obj.params.common.item_type},
			dataType: "json"
		})
		.done(function(data) {
			if (data.error) {
				// Error Message
				displayUserMessage(data.error, true);
			} else {
				selectFields.each(function(key, field) {
					var stateTag = $(field).attr("data-state");

					// Build each select option
					$(field).append("<option value='-1'></option>");
					if ($(field).attr("multiple")) {
						var langState = "PLAN_RACK_STATE_" + stateTag.toUpperCase();

						$(field).append("<option value='-2'>" + glob_lang.ALL_SERVICES + "-" + glob_lang[langState] + "</option>");
					}
					$.each(data.services, function(k, service) {
						$(field).append("<option value='" + service.id + "'>" + service.name + " [" + service.plugin_name + "]" + "</option>");
					});

					// Auto selection of services by plugin tag
					if (data.autoSelect[stateTag] !== null) {
						$("option[value='" + data.autoSelect[stateTag] + "']", field).prop("selected", true);
					}

					$(field).trigger("change");
					$(field).trigger("chosen:updated");
				});
			}
		});
	}
}

// Handle the node and content selection changes
function onChangeRackItemNodeSelect(obj) {
	// On page load, enable content field if node field is not empty
	if ($("#selectNode").val().length != 0) {
		$(".selectServicesStates").each(function() {
			$(this).prop("disabled", false);
			$(this).trigger("chosen:updated");
		});
	}

	if (obj.params.config == undefined)
	{
		obj.params.config = {};
	}

	// On change
	$("#selectNode").change(function() {
		// Update device_id
		obj.params.config.device_id = $("#selectNode").val();
		// Clean content fields for each item services
		$(".selectServicesStates").each(function() {
			$(this).empty();
			$(this).prop("disabled", false);
		});

		updRackItemSelectServices(obj, $(".selectServicesStates"));
	});

	// Disabled other options in multi select when all services type is selected
	var handleMultiSelectOptsFct = function(select) {
		if (select.val()?.includes("-2")) {
			$("option", select).each(function(key, opt) {
				// Unselect all opts
				$(opt).prop("selected", false);

				if ($(opt).attr("value") == -2) {
					// Reselect the all services opt
					$(opt).prop("selected", true);
				} else if ($(opt).attr("value") > 0) {
					// Disable other services opts
					$(opt).prop("disabled", true);
				}
			});

			select.trigger("liszt:updated");
		} else {
			// Re-enable disbaled options if there is some
			$("option[disabled]", select).each(function(key, opt) {
				$(opt).prop("disabled", false);
			});
		}

		select.trigger("chosen:updated");
	};
	// Init on page load
	$(window).load(function() {
		$(".selectServicesStates[multiple]").each(function() {
			handleMultiSelectOptsFct($(this));
		});
	});
	// On select value change
	$(".selectServicesStates[multiple]").change(function() {
		handleMultiSelectOptsFct($(this));
	});
}

// Handle saving new object configuration parameters
function updObjRackItemEvent(obj, planId) {
	$("#formUpdObjRackItem").submit(function(e) {
		e.preventDefault();

		var formData = getFormValues('formUpdObjRackItem'),
			objParams = {};

		if (!$.isNumeric(obj.id)) {
			objParams = obj.params;
		}

		$.ajax({
			type: "POST",
			url: $(this).attr("action"),
			data: { isJSONResp: true, ...formData, obj_params_old: objParams },
			dataType: "json"
		})
		.done(function(data) {
			if (data.error) {
				// Error Message
				displayUserMessage(data.error, true, 'dialog-messages');
			} else {
				// If new object change it's attributes data on the plan
				if (!$.isNumeric(obj.id)) {
					$("#" + obj.id + "object").remove();
					adm_setObjectRackItem(data, data.tmp_params.device_name);
				} else {
					// Update device name
					$("#" + data.id + "object").attr("title", data.tmp_params.device_name || "");
				}
				// Close dialog window
				$("#dialog-info").dialog("close");
			}
		});
	});
}

// Init plan rack item object configuration
function initRackItemObjConf(obj, planId) {
	onChangeRackItemNodeSelect(obj);
	updObjRackItemEvent(obj, planId);
}

// Set rack view mode behaviour
function initPlanRackView() {
	setPlanSize();
	setRackEmtyUSeparators();
}

// Set some admin mode behaviour
function initPlanRackAdm() {
	setPlanSize();
	dropObjInRack();
	initPlanIconsMenu();
	dragMenuRackItem();
	showHideTrashContent();
	handleRackParameters();
	updatePlanRack();
	handlePlanHasUnsavedChanges();
	openEmptyTrashDialog();
	setRackEmtyUSeparators();
	setPlanResizable();
	addTooltipTitle($('.plan-tool'));
}

// Add separators when some U are hidden
function setRackEmtyUSeparators() {
	// Reset all reduced U separators
	$(".rack-u-parts .reducedU").remove();

	// Set new reduced U separators
	if ($(".empty-u-hidden").length > 0) {
		// Get all U sorted by descending U number
		var racksU = $(".empty-u-hidden .rack-u").sort(function(a, b) {
				return parseInt($(b).attr("data-u")) - parseInt($(a).attr("data-u"));
			}),
			reducedUTopIndex = 0;

		// Add separator after each empty U followed by a not empty U or if the last U (U1) is empty
		for (var i = 0; i < racksU.length; i++) {
			if ($(racksU[i]).attr("data-link-id") == 0 && (i == 0 || $(racksU[i - 1]).attr("data-link-id") != 0)) {
				$("<div>", {"class": "reducedU reducedU-top"}).insertBefore($(racksU[i]));
				reducedUTopIndex = i;
			}
			if ($(racksU[i]).attr("data-link-id") == 0 && (i == racksU.length - 1 || $(racksU[i + 1]).attr("data-link-id") != 0)) {
				$("<div>", {"class": "reducedU reducedU-bottom"}).insertAfter($(racksU[i]));
				$("<div>", {"class": "reducedUNbr", "data-reduced-nbr": (i + 1) - reducedUTopIndex}).insertBefore($(racksU[i]));

			}
		}
	}
}
