/* Text tool */
// Supprime les tags HTMl qui peuvent êtres dangereux dans les texts box
function removeHTMLTags(text) {
	var tagsWithClosure = ["iframe", "script"], // exemple: <script>monscript</script>
		tagsSingleLine = ["link", "meta", "\\?"]; // exemple: <link href="" rel="stylesheet"> (le "\\?" prends le php <?php code ?>)

	$.each(tagsWithClosure, function() {
		var regexWithClosure = new RegExp("<" + this + "[\\s\\S]*?<\/" + this + ">", "gim");

		text = text.replace(regexWithClosure, "");
	});
	$.each(tagsSingleLine, function() {
		var regexSingleLine = new RegExp("<" + this + "[\\s\\S]*?>", "gim");

		text = text.replace(regexSingleLine, "");
	});

	return text;
}

// Convertis les retours à la ligne format plain text en <br> html ou inversément
// function convertTextLinesBreak(text, convertToHTML=false, convertToPlainText=false) {
//	 if (convertToHTML) {
//		 text = text.replace(/(\r\n|\n\r|\r|\n)/gm, "<br>");
//	 } else if (convertToPlainText) {
//		 text = text.replace(/(<br[\s\S]*?>)/gm, "\n");  // Tous les <br> ou <br/> ou <br />
//	 }
//
//	 return text;
// }

// Get obj type text styles
function getObjTextStyles(box, content) {
	var style = {
			"fontColor": rgbToHex(box.css("color")),
			"fontSize": parseInt(box.css("font-size")),
			"bgColor": rgbToHex(box.css("background-color")),
			"bgOpacity": getRgbaOpacity(box.css("background-color")),
			"borderColor": rgbToHex(box.css("border-top-color")), // jquery ne prends pas la propriété raccourcie border-color
			"borderWidth": parseInt(box.css("border-top-width")),
			"borderRadTopLeft": parseInt(box.css("border-top-left-radius")),
			"borderRadTopRight": parseInt(box.css("border-top-right-radius")),
			"borderRadBottomRight": parseInt(box.css("border-bottom-right-radius")),
			"borderRadBottomLeft": parseInt(box.css("border-bottom-left-radius")),
			"padTop": parseInt(content.css("padding-top")),
			"padRight": parseInt(content.css("padding-right")),
			"padBottom": parseInt(content.css("padding-bottom")),
			"padLeft": parseInt(content.css("padding-left"))
		};

	return style;
}

// Formate les paramètres d'un objet HTML dans le format dont ces paramètres sont stocké en DB
function getTextParams(container, textBox, textContent, textString) {
	var position = {
			"x": container.position().left + $("#plan" + glob_plan.id).scrollLeft(),
			"y": container.position().top + $("#plan" + glob_plan.id).scrollTop(),
			"z": 1
		},
		size = {
			"width": textBox.outerWidth(),
			"height": textBox.outerHeight()
		},
		params = {
			"position": position,
			"size": size,
			"text": textString,
			"style": getObjTextStyles(textBox, textContent),
		};

	return params;
}

// Applique les paramètres style sur un text-box depuis un objet params formaté comme pour le stockage en DB
function setObjTextStyles(params, textContent, textBox=false) {
	if (textBox) {
		textBox.css({
			"font-size": params?.style?.fontSize || "",
			"color": "#" + params?.style?.fontColor || "",
			"background-color": setRgba(params?.style?.bgColor || "", params?.style?.bgOpacity || ""),
			"border-color": setRgba(params?.style?.borderColor || "", 1),
			"border-width": params?.style?.borderWidth || 0,
			"border-top-left-radius": params?.style?.borderRadTopLeft + "px" || 0,
			"border-top-right-radius": params?.style?.borderRadTopRight + "px" || 0,
			"border-bottom-right-radius": params?.style?.borderRadBottomRight + "px" || 0,
			"border-bottom-left-radius": params?.style?.borderRadBottomLeft + "px" || 0
		});
	}
	textContent.css({
		"padding-top": params?.style?.padTop || 0,
		"padding-right": params?.style?.padRight || 0,
		"padding-bottom": params?.style?.padBottom || 0,
		"padding-left": params?.style?.padLeft || 0
	});
	// Avec la méthode jQuery.css, si aucune unité n'est précisée pour les tailles (em, %, ...) elle sera considérée comme en px. Si la propriété n'existe pas dans l'objet || "" permet de supprimer une propriété appliqué en js et laisse la propriété css initiale définie dans plan.css sur .plan-text-content
}

// Applique les paramètres text sur un text-box
function setObjTextContent(textContent, text) {
	textContent.html(text);
}

// Applique les paramètres size, style et text sur un text-box depuis un objet params formaté comme pour le stockage en DB
function setTextParams(params, textContent, textBox=false) {
	if (textBox) {
		textBox.css({
			"width": params?.size?.width || "",
			"height": params?.size?.height || "",
		});
	}
	setObjTextContent(textContent, params?.text || "");

	setObjTextStyles(params, textContent, textBox);
	// Le positionnement est appliqué au parent.
}

// Set l'événement d'ouverture de la boite d'actions d'édition
function clickTextOpenActionsEvent(container) {
	container.on("click.openactions", function() {
		if (container.find(".plan-obj-infos").length == 0) {
			editTextObj(container);
		}
	});
}

// Evénements sur l'objet texte en mode edition
function setObjTextEventsHandler(container) {
	// Ouverture de la boite d'actions d'édition au click
	clickTextOpenActionsEvent(container); // On set l'événement

	container.on("dragstart", function() { // Lors du drag&drop, on ne doit pas ouvrir les actions d'édition donc on doit supprimer l'événement
		container.off("click.openactions");
	});

	container.on("dragstop", function() { // Lorsque le drag&drop s'arrète, on reset l'événement
		clickTextOpenActionsEvent(container);
	});
	/////////////////////////////////
}

// Au chargement de la page vue du plan, crée les objets texts de ce plan stocké dans la DB.
function setObjectTextOnPlan(obj) {
	var plan = $("#plan" + glob_plan.id),
		textBox = $("<div>", {"id": obj.id.toString() + "object", "class": "plan-text-box planObjView"}),
		text = $("<pre>", {"class": "plan-text-content plan-text-view"});

	textBox.css({
		"top": obj?.params?.position?.y || 0,
		"left": obj?.params?.position?.x || 0,
		"width": obj?.params?.size?.width || "",
		"height": obj?.params?.size?.height || "",
		"font-size": obj?.params?.style?.fontSize || "",
		"color": "#" + obj?.params?.style?.fontColor || "",
		"background-color": setRgba(obj?.params?.style?.bgColor || "", obj?.params?.style?.bgOpacity || ""),
		"border-color": setRgba(obj?.params?.style?.borderColor || "", 1),
		"border-width": obj?.params?.style?.borderWidth || "",
		"border-top-left-radius": obj?.params?.style?.borderRadTopLeft + "px" || "",
		"border-top-right-radius": obj?.params?.style?.borderRadTopRight + "px" || "",
		"border-bottom-right-radius": obj?.params?.style?.borderRadBottomRight + "px" || "",
		"border-bottom-left-radius": obj?.params?.style?.borderRadBottomLeft + "px" || "",
	});
	text.css({
		"padding-top": obj?.params?.style?.padTop || "",
		"padding-right": obj?.params?.style?.padRight || "",
		"padding-bottom": obj?.params?.style?.padBottom || "",
		"padding-left": obj?.params?.style?.padLeft || ""
	});
	text.html(obj?.params?.text || "");
	// Avec la méthode jQuery.css, si aucune unité n'est précisée pour les tailles (em, %, ...) elle sera considérée comme en px. Si la propriété n'existe pas dans l'objet || "" permet de supprimer une propriété appliqué en js et laisse la propriété css initiale définie dans plan.css sur .plan-text-content
	// Le positionnement est appliqué au parent.

	textBox.append(text);
	plan.append(textBox);
}

// Au chargement de la page admin, crée les objets texts de ce plan stocké dans la DB.
function adm_setObjectTextOnPlan(obj) {
	var plan = $("#plan" + glob_plan.id),
		textBox = $("<div>", {"class": "plan-text-box"}),
		text = $("<pre>", {"class": "plan-text-content plan-text-adm-view"}),
		container = $("<div>", {
			"id": obj.id.toString() + "object",
			"class": "planObj objText",
			"data-id": obj.id,
			"data-type": obj.type_name
		});

	container.css({
		"top": obj?.params?.position?.y || 0,
		"left": obj?.params?.position?.x || 0
	});

	setTextParams(obj.params, text, textBox);
	dragPlanToolObj(container);
	setObjTextEventsHandler(container);

	plan.append(container);
	textBox.append(text);
	container.append(textBox);
}

// Set text object resizable
function setResizeTextObj(plan, container, textBox, textEdit) {
	container.resizable({
		disabled: false,
		containment: plan,
		alsoResize: textBox, // C'est sur lui que la taille de l'objet est récupéré
		minWidth: parseInt(textBox.css("font-size")) * 1.75,
		minHeight: parseInt(textBox.css("font-size")) * 1.5,
		start: function(e, ui) {
			// Vu que le textBox doit être en box-sizing: border-box, il faut gérer les différences de tailles si il y a une bordure
			var resizeHeightCorrection = textBox.outerHeight() - textBox.height(),
				resizeWidthCorrection = textBox.outerWidth() - textBox.width();

			ui.size.height += resizeHeightCorrection;
			ui.size.width += resizeWidthCorrection;
		},
		resize: function(e, ui) {
			// Garder la hauteur du textarea a la hauteur de son contenu
			textEdit.css("height", 0); // D'abord, on set height a 0 pour reinitialiser sa valeur scrollHeigh
			textEdit.css("height", textEdit.prop("scrollHeight"));
		}
	});
}

function closeEditTextMenu(container) {
	closeObjectEditMenu(container);
	$(".plan-text-edit", container).remove();
	$(".plan-text-adm-view", container).show();
}

// Passe l'objet texte du mode visualisation en mode édition
function editTextObj(container) {
	var planId = $("#currentPlan").data("id"),
		objId = container.data("id"),
		textEdit = $("<textarea>", {"class": "plan-text-content plan-text-edit", "placeholder": glob_lang.PLAN_TOOLS_TEXT_PLACEHOLDER}),
		actions = $("<div>", {"class": "plan-obj-actions"}),
		acceptButton = $("<button>", {"class": "obj-action accept-action", "type": "button", "title": glob_lang.PLAN_MODIFY_VALIDATE}),
		refuseButton = $("<button>", {"class": "obj-action refuse-action", "type": "button", "title": glob_lang.PLAN_MODIFY_ABORT}),
		modifyButton = $("<button>", {"class": "obj-action modify-action", "type": "button", "title": glob_lang.PLAN_MODIFY}),
		delButton = $("<button>", {"class": "obj-action delete-action", "type": "button", "title": glob_lang.PLAN_DELETE}),
		resizeButton = $("<button>", {"class": "obj-action resize-action", "type": "button", "title": glob_lang.PLAN_RESIZE}),
		cloneButton = $("<button>", {"class": "obj-action clone-action", "type": "button", "title": glob_lang.PLAN_CLONE}),
		textBox = container.find(".plan-text-box"),
		textObj = textBox.find(".plan-text-adm-view"),
		text = textObj.html(),
		textObjParams = getTextParams(container, textBox, textObj, text);

	actions.append(modifyButton).append(cloneButton).append(resizeButton).append(delButton).append(acceptButton).append(refuseButton);
	initObjectEditMenu(container, actions);

	textBox.append(textEdit);

	textObj.hide();
	textEdit.focus();
	setTextParams(textObjParams, textEdit);
	// Fixer la hauteur du textarea a la hauteur de son contenu
	textEdit.css("height", textEdit.prop("scrollHeight"));
	textEdit.on("input", function() {
		$(this).css("height", $(this).prop("scrollHeight"));
	});

	// Validation des modifications du text
	acceptButton.on("click", function() {
		var params = {text: removeHTMLTags(textEdit.val())};

		$.ajax({
			type: "POST",
			url: glob_apache_path + "control_tools.php?action=updateObjText&id=" + glob_plan.id,
			data: {object: objId, params: JSON.stringify(params)},
			dataType: "html"
		})
		.done(function(data) {
			if (data.error) { // Error Message
				displayUserMessage(data.error, true);
			}
		});

		setObjTextContent(textObj, params.text);
		closeEditTextMenu(container);
	});

	// Annuler les modifications du text
	refuseButton.on("click", function() {
		closeEditTextMenu(container);
	});

	// Modifier les paramètres de l'objet texte (styles)
	modifyButton.on("click", function() {
		// Valid unsaved text update
		acceptButton.trigger("click");

		// Open conf dialog
		if ($.isNumeric(planId) && $.isNumeric(objId)) {
			var text = removeHTMLTags(textEdit.val()),
				params = getTextParams(container, textBox, textEdit, text),
				object = JSON.stringify({
					id: objId,
					type_name: "text",
					params: params
				}),
				url = glob_apache_path + "control_tools.php?action=confObjText&id=" + glob_plan.id + "&plan=" + planId + "&obj=" + object;

			openConfObjDialog(url, glob_lang.PLAN_TOOLS_TEXT_CONF);
			closeEditTextMenu(container);
		}
	});

	// Suppression de l'objet texte
	delButton.on("click", function() {
		actionDeleteObject(objId, actions);
	});

	var fctOnResizeRefused = function() {
		// Rétablir les tailles initiales
		container.css({
			"width": "",
			"height": ""
		});
		textBox.css({
			"width": textObjParams.size.width,
			"height": textObjParams.size.height
		});
	};

	// Resize object
	resizeButton.on("click", function() {
		setResizeTextObj($("#plan" + glob_plan.id), container, textBox, textEdit);
		actionResizeObject(objId, actions, container, true, fctOnResizeRefused);
	});

	// Dupliquer l'objet texte
	cloneButton.on("click", function(e) {
		// Valider les éventuelles modifications sur l'object initiale avant de dupliquer
		$(".accept-action", container).trigger("click");

		var text = textObj.html(),
			cloneTextParams = getTextParams(container, textBox, textObj, text),
			objCloned = {
				id: container.attr("data-id"),
				type_name: "text",
				name: planId + "-text",
				params: cloneTextParams
			};

		duplicateObjByClick(e, objCloned, adm_setObjectTextOnPlan);
	});
}

// Créer un nouvel objet texte depuis l'outils de création de texte
function createNewObjText(position) {
	var plan = $("#plan" + glob_plan.id),
		planId = plan.data("id"),
		textEdit = $("<textarea>", {"class": "plan-text-content plan-text-edit", "placeholder": glob_lang.PLAN_TOOLS_TEXT_PLACEHOLDER}),
		actions = $("<div>", {"class": "plan-obj-actions"}),
		acceptButton = $("<button>", {"class": "obj-action accept-action", "type": "button", "title": glob_lang.PLAN_MODIFY_VALIDATE}),
		delButton = $("<button>", {"class": "obj-action delete-action", "type": "button", "title": glob_lang.PLAN_DELETE}),
		textBox = $("<div>", {"class": "plan-text-box"}),
		tmpObj = $("<div>", {"id": 'tmp-' + Date.now(), "class": "planObj objText"}),
		name = planId + "-text";

	textBox.append(textEdit);
	tmpObj.append(textBox);
	plan.append(tmpObj);

	position = checkObjectOnPlanLimits(plan, textBox.width(), textBox.height(), position);

	tmpObj.css({
		"top": position.y,
		"left": position.x
	});

	dragPlanToolObj(tmpObj);

	textEdit.focus();

	// Init action menu
	actions.append(acceptButton).append(delButton);
	initObjectEditMenu(tmpObj, actions);

	// Validation des modifications
	$(".accept-action", tmpObj).on("click", function() {
		var text = removeHTMLTags(textEdit.val()),
			params = getTextParams(tmpObj, textBox, textEdit, text),
			newObj = {
				id: null,
				name: name,
				type_name: "text",
				params: params
			};

		newObj.params.position = {
			y: tmpObj.css("top").replace("px", ""),
			x: tmpObj.css("left").replace("px", ""),
		};

		tmpObj.remove();
		createNewToolObj(newObj, planId, adm_setObjectTextOnPlan);
	});

	// Suppression de l'objet texte
	$(".delete-action", tmpObj).on("click", function() {
		tmpObj.remove();
	});
}

// Affiche dans la preview en temp réel les modification en cours sur l'objet texte
function planTxtPrevLiveStyles(prevTextBox) {
	var prevTextContent = prevTextBox.find(".plan-text-content");

	// Font
	$("#fontSize").on("change", function() {
		prevTextBox.css("font-size", this.value);
	});

	$("#fontColor").on("change", function() {
		prevTextBox.css("color", this.value);
	});

	// Background
	$("#bgColor, #bgOpacity").on("change", function() {
		prevTextBox.css("background-color", setRgba($("#bgColor").val(), $("#bgOpacity").val()));
	});

	// Border
	$("#borderColor").on("change", function() {
		prevTextBox.css("border-color", this.value);
	});

	$("#borderWidth").on("change", function() {
		prevTextBox.css("border-width", this.value);
	});

	// Border radius (Avec la méthode jQuery .css, pour le border radius l'unité en px est nécessaire)
	$("#topLeftRad").on("change", function() {
		prevTextBox.css("border-top-left-radius", this.value + "px");
		if ($(this).hasClass("overhide")) {
			prevTextBox.css({
				"border-top-right-radius": this.value + "px",
				"border-bottom-left-radius": this.value + "px",
				"border-bottom-right-radius": this.value + "px",
			});
		}
	});

	$("#topRightRad").on("change", function() {
		prevTextBox.css("border-top-right-radius", this.value + "px");
	});

	$("#bottLeftRad").on("change", function() {
		prevTextBox.css("border-bottom-left-radius", this.value + "px");
	});

	$("#bottRightRad").on("change", function() {
		prevTextBox.css("border-bottom-right-radius", this.value + "px");
	});

	// Padding
	$("#topPad").on("change", function() {
		prevTextContent.css("padding-top", this.value);
		if ($(this).hasClass("overhide")) {
			prevTextContent.css({
				"padding-left": this.value,
				"padding-right": this.value,
				"padding-bottom": this.value,
			});
		}
	});

	$("#leftPad").on("change", function() {
		prevTextContent.css("padding-left", this.value);
	});

	$("#rightPad").on("change", function() {
		prevTextContent.css("padding-right", this.value);
	});

	$("#bottPad").on("change", function() {
		prevTextContent.css("padding-bottom", this.value);
	});
}

// Récupère les modifications tel qu'elles apparaissent dans la preview et les renvoie au controller
function sendNewTxtStyles(obj, prevTextBox) {
	var prevTextContent = prevTextBox.find(".plan-text-content"),
		params = {style: getObjTextStyles(prevTextBox, prevTextContent)};

	$.ajax({
		type: "POST",
		url: glob_apache_path + "control_tools.php?action=updateObjText&id=" + glob_plan.id,
		data: {object: obj.id, params: JSON.stringify(params)},
		dataType: "json"
	})
	.done(function(data) {
		if (data.error) {
			// Message d'erreur
			displayUserMessage(data.error, true);
		} else {
			// On applique les nouveaux parametres sur l'objet du plan initial
			var mainWindowTextBox = window.parent.$("#" + obj.id.toString() + "object").find(".plan-text-box"), // window.parent permet de quitter l'iframe pour revenir dans le document principale.
				mainWindowTextContent = mainWindowTextBox.find(".plan-text-content");

			setObjTextStyles(params, mainWindowTextContent, mainWindowTextBox);
			// On ferme la fenetre pop-up
			window.parent.$("#dialog-info").dialog("close"); // C'est a partir du document principale que l'on doit appeler la méthode dialog("close").
		}
	});
}

// Init plan text object configuration
function initTxtObjConf(obj, planId, planController) {
	// Requete ajax pour créer le plan pour la preview
	createPlanPreviewPromise(obj, planId, planController).then(function() {
		var prevObj = $(".plan-preview #" + obj.id + "object"),
			prevTextContent = prevObj.find(".plan-text-content");

		setTextParams(obj.params, prevTextContent, prevObj); // For resizing not validated

		// Au chargement du pop-up déploie ou non les inputs des style-action (Angles de la boite, espacement...). Si toutes les inputs on la même valeur, on reste en mode d'affichage a une seule input. Si une seule des valeurs est différente, on deploie les autres inputs.
		initStyleActions();

		// Evénements de modification de styles et visualiation en directe dans la fenètre de prévisualisation
		planTxtPrevLiveStyles(prevObj);

		// Sauvegarder les modifications
		$("#sendFormTxtUpd").on("click", function(e) {
			e.preventDefault();

			sendNewTxtStyles(obj, prevObj);
		});
	});
}

// Init plan text in tool bar
function initPlanToolText() {
	$(".plan-tool-text").on("click", function(e) {
		createObjByClick(e, "text", createNewObjText);
	});
}
